/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//CvO
//	FileName	Main.c
//	Version		1.00
//	MCU		H8/3694
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/19	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	rbhʐM\tgœ͂f[^ddoqnlɏ݂܂
//	񂾒ĺAɒʐM\tgɕԂĕ\܂B
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
/* }CRCu */
#include <machine.h>

/* WbCu */

/* IWi */
#include "3694S.h"
#include "Main.h"
#include "EEPROM.h"
#include "SCI.h"


/*
/////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/
const char *Title = "\r\nAT93C46 Sample program running...\r\n";


/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void PowerOnReset ( void );
void Main ( void );
void Init ( void );
void Wait ( const unsigned long Interval );


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/


/*
///////////////////////////////////////////////////////////////////////////////
//PowerOnReset
//Ep[IZbg
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void PowerOnReset ( void )
{
	set_imask_ccr ( 0 );
	_INITSCT ();
	Main ();
	sleep ();
}


/*
///////////////////////////////////////////////////////////////////////////////
//Main
//EvOC
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Main ( void )
{
	int i;
	char String[ 255 ];
	unsigned short Charactor;
	
	
	Init ();
	
	
	Write_SCI ( strlen ( Title ), Title );
	
	
	ewen_rom ();
	
	
	while ( 1 )
	{
		memset ( String, '\0', sizeof ( String ) );
		
		
		Write_SCI ( strlen ( "\r\nInput> " ), "\r\nInput> " );
		for ( i = 0; i < sizeof ( String ) - 1; ++i )
		{
			Read_SCI ( 1, &String[ i ] );
			Write_SCI ( 1, &String[ i ] );
			Charactor = ( unsigned char )String[ i ];
			write_rom ( i, Charactor );
			if ( String[ i ] == '\r' || String[ i ] == '\n' )
				break;
		}
		
		
		Write_SCI ( strlen ( "\r\Output> " ), "\r\nOutput> " );
		for ( i = 0; i < sizeof ( String ) - 1; ++i )
		{
			read_rom ( i, &Charactor );
			String[ i ] = ( unsigned char )Charactor;
			Write_SCI ( 1, &String[ i ] );
			if ( String[ i ] == '\r' || String[ i ] == '\n' )
				break;
		}
	}
}


/*
///////////////////////////////////////////////////////////////////////////////
//Init
//EvO
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Init ( void )
{
	Init_SCI ( VAL_SCI_CH_0, 20, 2400 );
	Init_EEPROM ();
}


/*
///////////////////////////////////////////////////////////////////////////////
//Wait
//EvOҋ@
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Wait ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i ) {}
}
